# FoundationClasses
TKernel
NCollection

# NCollection_BaseMap Class Reference

`#include <NCollection_BaseMap.hxx>`

Inheritance diagram for NCollection_BaseMap:

[legend]

## Public Member Functions

Standard_Integer | NbBuckets () const
| NbBuckets.
Standard_Integer | Extent () const
| Extent.
Standard_Boolean | IsEmpty () const
| IsEmpty.
Standard_EXPORT void | Statistics (Standard_OStream &S) const
| Statistics.

## Protected Member Functions

| NCollection_BaseMap (const Standard_Integer NbBuckets, const Standard_Boolean single)
| Constructor.
Standard_EXPORT Standard_Boolean | BeginResize (const Standard_Integer NbBuckets, Standard_Integer &NewBuckets, NCollection_ListNode **&data1, NCollection_ListNode **&data2, Handle(NCollection_BaseAllocator)&theAllocator) const
| BeginResize.
Standard_EXPORT void | EndResize (const Standard_Integer NbBuckets, const Standard_Integer NewBuckets, NCollection_ListNode **data1, NCollection_ListNode **data2, Handle(NCollection_BaseAllocator)&theAllocator)
| EndResize.
Standard_Boolean | Resizable () const
| Resizable.
void | Increment ()
| Increment.
void | Decrement ()
| Decrement.
Standard_EXPORT void | Destroy (NCollection_DelMapNode fDel, Handle(NCollection_BaseAllocator)&theAllocator, const Standard_Boolean doReleaseMemory=Standard_True)
| Destroy.
Standard_EXPORT Standard_Integer | NextPrimeForMap (const Standard_Integer N) const
| NextPrimeForMap.

## Protected Attributes

NCollection_ListNode ** | myData1
NCollection_ListNode ** | myData2

## Private Attributes

Standard_Boolean | isDouble
Standard_Boolean | mySaturated
Standard_Integer | myNbBuckets
Standard_Integer | mySize

## Data Structures

class | Iterator

## Detailed Description

Purpose: This is a base class for all Maps: Map DataMap DoubleMap IndexedMap IndexedDataMap Provides utilitites for managing the buckets.

## Constructor & Destructor Documentation

NCollection_BaseMap::NCollection_BaseMap | ( | const Standard_Integer | NbBuckets,
|  | const Standard_Boolean | single
| ) | `[inline, protected]`

## Member Function Documentation

Standard_EXPORT Standard_Boolean NCollection_BaseMap::BeginResize | ( | const Standard_Integer | NbBuckets,
|  | Standard_Integer & | NewBuckets,
|  | NCollection_ListNode **& | data1,
|  | NCollection_ListNode **& | data2,
|  | Handle(NCollection_BaseAllocator)& | theAllocator
| ) | const`[protected]`

void NCollection_BaseMap::Decrement | ( |  | ) | `[inline, protected]`

Standard_EXPORT void NCollection_BaseMap::Destroy | ( | NCollection_DelMapNode | fDel,
|  | Handle(NCollection_BaseAllocator)& | theAllocator,
|  | const Standard_Boolean | doReleaseMemory = `Standard_True`
| ) | `[protected]`

Standard_EXPORT void NCollection_BaseMap::EndResize | ( | const Standard_Integer | NbBuckets,
|  | const Standard_Integer | NewBuckets,
|  | NCollection_ListNode ** | data1,
|  | NCollection_ListNode ** | data2,
|  | Handle(NCollection_BaseAllocator)& | theAllocator
| ) | `[protected]`

Standard_Integer NCollection_BaseMap::Extent | ( |  | ) | const`[inline]`

void NCollection_BaseMap::Increment | ( |  | ) | `[inline, protected]`

Standard_Boolean NCollection_BaseMap::IsEmpty | ( |  | ) | const`[inline]`

Standard_Integer NCollection_BaseMap::NbBuckets | ( |  | ) | const`[inline]`

Standard_EXPORT Standard_Integer NCollection_BaseMap::NextPrimeForMap | ( | const Standard_Integer | N | ) | const`[protected]`

Standard_Boolean NCollection_BaseMap::Resizable | ( |  | ) | const`[inline, protected]`

Standard_EXPORT void NCollection_BaseMap::Statistics | ( | Standard_OStream & | S | ) | const

## Field Documentation

Standard_Boolean NCollection_BaseMap::isDouble `[private]`

NCollection_ListNode** NCollection_BaseMap::myData1 `[protected]`

NCollection_ListNode** NCollection_BaseMap::myData2 `[protected]`

Standard_Integer NCollection_BaseMap::myNbBuckets `[private]`

Standard_Boolean NCollection_BaseMap::mySaturated `[private]`

Standard_Integer NCollection_BaseMap::mySize `[private]`

The documentation for this class was generated from the following file:

- NCollection_BaseMap.hxx